module crypted.digest_speed;

import crypted.digests.MD5;
import crypted.digests.SHA0;
import crypted.digests.SHA1;
import crypted.digests.Tiger;

import time;

extern (Windows) {
/*
function timeBeginPeriod( prec : LongInt ) : LongInt; stdcall; external 'winmm.dll';
function timeGetTime( ) : LongInt; stdcall; external 'winmm.dll';
function timeEndPeriod( prec : LongInt ) : LongInt; stdcall; external 'winmm.dll';
*/
//	int timeBeginPeriod( int prec );
//	int timeGetTime( );
//	int timeEndPeriod( int prec );
}

void testDigestSpeed()
{
//	timeBeginPeriod( 1 );
	runSpeedTest( new MD5(), "md5" );
	runSpeedTest( new SHA0(), "sha0" );
	runSpeedTest( new SHA1(), "sha1" );
	runSpeedTest( new Tiger(), "Tiger" );
//	timeEndPeriod( 1 );
}

void runSpeedTest( MessageDigest md, char[] name )
{
	time_t start, t1m, t1k, t1b, tm;
	byte[] z1b = new byte[1];
	byte[] z1k = new byte[1024];
	byte[] z1m = new byte[1024*1024];

	printf("testing %.*s expect a 3 to 10 minute delay\n", name );
	/* run the code to flush the old cache and init it ready for the timing run */
	md.init(); md.update( z1k ); md.digest();

//	start = timeGetTime();
	start = time.time( &tm );
	printf("start =%d, tm=%d\n", start, tm );
	md.init();
	for( int i = 0; i < 1024; i++ )
	{
		md.update( z1m );
	}
	md.digest();
//	t1m = timeGetTime() - start;
	t1m = time.time( &tm ) - start;
	printf( "1M blocks - %ds (%dm)\n", t1m, t1m / 60 );

//	start = timeGetTime();
	start = time.time( &tm );
	md.init();
	for( int i = 0; i < 1024*1024; i++ )
	{
		md.update( z1k );
	}
	md.digest();
//	t1k = timeGetTime() - start;
	t1k = time.time( &tm ) - start;
	printf( "1K blocks - %ds (%dm)\n", t1k, t1k / 60 );
	
//	start = timeGetTime();
	time.time( &start );
	md.init();
	for( int i = 0; i < 100*1024*1024; i++ )
	{
		md.update( z1b );
	}
	md.digest();
//	t1b = timeGetTime() - start;
	time.time( &tm );
	t1b = tm - start;

	printf( "1G hashed in\n" );
//	printf( "1M blocks - %dms (%ds)\n", t1m, t1m / 1000 );
//	printf( "1K blocks - %dms (%ds)\n", t1m, t1k / 1000 );
//	printf( "1B blocks - %dms (%ds)\n", t1m, t1b / 1000 );
	printf( "1M blocks - %ds (%dm)\n", t1m, t1m / 60 );
	printf( "1K blocks - %ds (%dm)\n", t1k, t1k / 60 );
	printf( "100K hashed in\n" );
	printf( "1B blocks - %ds (%dm)\n", t1b, t1b / 60 );
	printf( "- -- - -- - -- - -- - -- - -- - -- - -- - -- -\n" );
}


