module crypted.digests.md;

class MessageDigest
{
public:
	abstract void   init();
	abstract void   update( byte * buf, int length );
	abstract byte[] digest();
	abstract int    digestBitLength();
//	MessageDigest clone(); // I'm not 100% about cloning as there is no 'this' return type.
protected:
	this()
	{
		init();
	}
public:
	void update( byte[] buf, int offset, int length )
	{
		assert( (offset|length) > 0 );
		assert( (offset+length) <= buf.length );
		//assert( (offset|length|((offset+length)-buf.length)) > 0 );

		update( &(buf[offset]), length );
	}

	void update( byte[] buf )
	{
		update( &(buf[0]), buf.length );
	}


	static void hexdump( byte[] buf )
	{
		int len = buf.length, i = 0;
		while( len > 16 )
		{
			printf( "%04x - ", i );
			for( int j = 0; j < 16; j++ )
			{
				printf( "%02x ", buf[i++] &0xFF );
			}
			printf( "\n" );
			len -=16;
		}
		printf( "%04x - ", i );
		for( int j = 0; j < len; j++ )
		{
			printf( "%02x ", buf[i++] & 0xFF );
		}
		printf( "\n" );
		len -=16;
	}
}

