public class TestSpeed {

static void testDigestSpeed()
{
//	timeBeginPeriod( 1 );
	runSpeedTest( new MD5(), "md5" );
	runSpeedTest( new SHA0(), "sha0" );
	runSpeedTest( new SHA1(), "sha1" );
	runSpeedTest( new Tiger(), "Tiger" );
//	timeEndPeriod( 1 );
}

static void runSpeedTest( PaddingMD md, String name )
{
	long start, t1m, t1k, t1b, tm;
	byte[] z1b = new byte[1];
	byte[] z1k = new byte[1024];
	byte[] z1m = new byte[1024*1024];

	System.out.println( "testing "+name+" expect a 3 to 10 minute delay" );
	/* run the code to flush the old cache and init it ready for the timing run */
	md.init(); md.update( z1k ); md.digest();

//	start = timeGetTime();
	start = System.currentTimeMillis();
	md.init();
	for( int i = 0; i < 1024; i++ )
	{
		md.update( z1m );
	}
	md.digest();
//	t1m = timeGetTime() - start;
	t1m = System.currentTimeMillis() - start;
	System.out.println( "1M blocks - " + t1m + "ms " + (t1m / 1000) + "s" );

	start = System.currentTimeMillis();
	md.init();
	for( int i = 0; i < 1024*1024; i++ )
	{
		md.update( z1k );
	}
	md.digest();
//	t1k = timeGetTime() - start;
	t1k = System.currentTimeMillis() - start;
	System.out.println( "1K blocks - " + t1k + "ms " + (t1k / 1000) + "s" );
	
	start = System.currentTimeMillis();
	md.init();
	for( int i = 0; i < 100*1024*1024; i++ )
	{
		md.update( z1b );
	}
	md.digest();
//	t1b = timeGetTime() - start;
	t1b = System.currentTimeMillis() - start;

	System.out.println( "1G hashed in" );
//	printf( "1M blocks - %dms (%ds)\n", t1m, t1m / 1000 );
//	printf( "1K blocks - %dms (%ds)\n", t1m, t1k / 1000 );
//	printf( "1B blocks - %dms (%ds)\n", t1m, t1b / 1000 );
	System.out.println( "1M blocks - " + t1m + "ms " + (t1m / 1000) + "s" );
	System.out.println( "1K blocks - " + t1k + "ms " + (t1k / 1000) + "s" );
	System.out.println( "100K hashed in" );
	System.out.println( "1B blocks - " + t1b + "ms " + (t1b / 1000) + "s" );
	System.out.println( "- -- - -- - -- - -- - -- - -- - -- - -- - -- -" );
}

	public static void main( String[] args )
	{
		testDigestSpeed();
	}
}


